/*
 * Software License Agreement (BSD License)
 *
 *  Point Cloud Library (PCL) - www.pointclouds.org
 *  Copyright (c) 2011-2012, Willow Garage, Inc.
 *  Copyright (c) 2012-, Open Perception, Inc.
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the copyright holder(s) nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PCL_IO_BOOST_H_
#define _PCL_IO_BOOST_H_

#if defined __GNUC__
#  pragma GCC system_header 
#endif
#ifndef __CUDACC__
//https://bugreports.qt-project.org/browse/QTBUG-22829
#ifndef Q_MOC_RUN
#ifndef Q_MOC_RUN
#include <boost/numeric/conversion/cast.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/thread/mutex.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/thread/condition.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/thread.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/thread/thread.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/filesystem.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/bind.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/cstdint.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/function.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/tuple/tuple.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/shared_ptr.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/weak_ptr.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/fold.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/inherit.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/inherit_linearly.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/joint_view.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/transform.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/mpl/vector.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/algorithm/string.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/date_time/posix_time/posix_time.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/chrono.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/tokenizer.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/foreach.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/shared_array.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/interprocess/sync/file_lock.hpp>
#endif
#if BOOST_VERSION >= 104900
#ifndef Q_MOC_RUN
#include <boost/interprocess/permissions.hpp>
#endif
#endif
#ifndef Q_MOC_RUN
#include <boost/iostreams/device/mapped_file.hpp>
#endif
#define BOOST_PARAMETER_MAX_ARITY 7
#ifndef Q_MOC_RUN
#include <boost/signals2.hpp>
#endif
#ifndef Q_MOC_RUN
#include <boost/signals2/slot.hpp>
#endif
#endif
#endif
#endif    // _PCL_IO_BOOST_H_

